<?php
namespace SM\Service;

use SM\Factory\Sm00054001ReducaoQuantidadeMedidaOperadorFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm00054001ReducaoQuantidadeMedidaOperadorService
{
    protected $connection;
    protected $Sm00054001ReducaoQuantidadeMedidaOperadorFactory;
    protected $environment;
    protected $newCode;

    public function __construct(Sm00054001ReducaoQuantidadeMedidaOperadorFactory $Sm00054001ReducaoQuantidadeMedidaOperadorFactory, Environment $environment, NewCode $newCode, EntityManager $entityManager)
    {
        $this->Sm00054001ReducaoQuantidadeMedidaOperadorFactory            = $Sm00054001ReducaoQuantidadeMedidaOperadorFactory;
        $this->environment               = $environment;
        $this->newCode                   = $newCode;
        $this->connection                = $entityManager->getConnection();
    }

    public function getReducaoQuantidadeMedidaOperador()
    {
        return $this->Sm00054001ReducaoQuantidadeMedidaOperadorFactory->getReducaoQuantidadeMedidaOperador();
    }
    
    public function inserirReducaoQuantidadeMedidaOperador($parametros)
    {
        $cdoperador = $this->environment->getCdOperador();
        $NRORG = $this->environment->getNrOrg();
        $this->connection->beginTransaction();

        $paramsaux = array(
          "CDOPERADOR" => $parametros[0]['CDOPERADOR'],
          "NRALTERAQTMEDOPER" => $parametros[0]['NRALTERAQTMEDOPER']
        );

        $dados = $this->Sm00054001ReducaoQuantidadeMedidaOperadorFactory->validaReducaoOperador($paramsaux);

        try {
            foreach ($parametros as $chave => $operador) {
                if ($operador["NRALTERAQTMEDOPER"] == 0) {
                    $NRALTERAQTMEDOPER = $this->newCode->getCodeByTableName("FCT_ALTERAQTMEDOPERADOR", $NRORG, 1, 10, true);
                    $dataParam = array(
                    "NRALTERAQTMEDOPER" => $NRALTERAQTMEDOPER,
                    "CDOPERADOR"   => $operador["CDOPERADOR"],
                    "NRORG"              => $NRORG,
                    "IDATIVO"       => "S",
                    "NRORGINCLUSAO"      => $NRORG,
                    "CDOPERINCLUSAO"     => $cdoperador,
                    );
                    if ($dados[0]["QTD"] > 0) {
                        throw new \Exception("EXISTE");
                    } else {
                        $this->Sm00054001ReducaoQuantidadeMedidaOperadorFactory->inserirReducaoQuantidadeMedidaOperador($dataParam);
                    }
                } else {
                    $dataParam = array(
                
                    "CDOPERADOR"   => $operador["CDOPERADOR"],
                    "NRORG"              => $NRORG,
                    "IDATIVO"       => "S",
                    "NRORGINCLUSAO"      => $NRORG,
                    "CDOPERINCLUSAO"     => $cdoperador,
                    "NRALTERAQTMEDOPER" => $operador["NRALTERAQTMEDOPER"],
                    );
                    if ($dados[0]["QTD"] > 0) {
                        throw new \Exception("EXISTE");
                    } else {
                        $this->Sm00054001ReducaoQuantidadeMedidaOperadorFactory->atualizarReducaoQuantidadeMedidaOperador($dataParam);
                    }
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
      
    public function deletarReducaoQuantidadeMedidaOperador($parametros)
    {
        $this->connection->beginTransaction();
        try {
            foreach ($parametros as $chave => $operador) {
                    $dataParam = array( "NRALTERAQTMEDOPER" => $operador["NRALTERAQTMEDOPER"],);
                    $this->Sm00054001ReducaoQuantidadeMedidaOperadorFactory->deletarReducaoQuantidadeMedidaOperador($dataParam);
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
