import { Utilities } from '@/util/Utilities';
import {
    Form, LoadingService, Select, TextInput,
} from '@zeedhi/common';
import { Http, Loader, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Sm00001001TabDocumentoPropostaController {
    public DocumentoProposta = Loader.getInstance('Sm00001001DocumentoPropostaController');

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
    
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public editarDocumentoProposta() {
        const gridDocumentoProposta = Metadata.getInstance<TekGrid>('tek-grid-documento_proposta_grid');
        const params = {
            IDSITUACAOORCAMENTO: Metadata.getInstance<Select>('formDadosDocumentoProposta-IDSITUACAOORCAMENTO').value,
            VRTAMANHOLOGO: Metadata.getInstance<TextInput>('formDadosDocumentoProposta-VRTAMANHOLOGO').value,
            NRSEQORCADOC: this.DocumentoProposta.currentRow.NRSEQORCADOC,
        };
        LoadingService.show();
        Http.post('/editarDocumentoProposta', params)
            .then(() => {
                Utilities.showSuccessMessage();
                gridDocumentoProposta.datasource.get();
                this.DocumentoProposta.voltarTekGridDocumentoProposta();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }
}
